#pragma once
#include <boost/asio/basic_waitable_timer.hpp>
#include <chrono>
#include <iostream>
#include <kr2_program_api/internals/api/console.h>
#include <functional>
#include <thread>
#include "util/i_watchdog_timer.h"


namespace spin
{

class WatchdogTimer : public IWatchdogTimer
{
public:
    WatchdogTimer();
    ~WatchdogTimer();

    void kick() override;
    void setUp(const long timeout_ms, const std::function<void()> onTimeout) override;

private:
    void restart();
    void handler(const boost::system::error_code& error);

    long timeout_ms_;
    std::function<void()> onTimeout_{[]() { std::cout << "Watchdog timeout callback not set." << std::endl; }};

    boost::asio::io_service io_service_;
    std::unique_ptr<boost::asio::basic_waitable_timer<std::chrono::steady_clock>> timer_;
    std::thread thread_;
};

} // namespace spin